(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@fortawesome/react-fontawesome'), require('prop-types'), require('react'), require('reactstrap')) :
  typeof define === 'function' && define.amd ? define(['exports', '@fortawesome/react-fontawesome', 'prop-types', 'react', 'reactstrap'], factory) :
  (factory((global['lemo-form'] = {}),global.FontAwesomeIcon,global.PropTypes,global.React,global.Reactstrap));
}(this, (function (exports,reactFontawesome,PropTypes,React,reactstrap) { 'use strict';

  PropTypes = PropTypes && PropTypes.hasOwnProperty('default') ? PropTypes['default'] : PropTypes;
  React = React && React.hasOwnProperty('default') ? React['default'] : React;

  var asyncToGenerator = function (fn) {
    return function () {
      var gen = fn.apply(this, arguments);
      return new Promise(function (resolve, reject) {
        function step(key, arg) {
          try {
            var info = gen[key](arg);
            var value = info.value;
          } catch (error) {
            reject(error);
            return;
          }

          if (info.done) {
            resolve(value);
          } else {
            return Promise.resolve(value).then(function (value) {
              step("next", value);
            }, function (err) {
              step("throw", err);
            });
          }
        }

        return step("next");
      });
    };
  };

  var classCallCheck = function (instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  };

  var createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  var _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  var inherits = function (subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  };

  var objectWithoutProperties = function (obj, keys) {
    var target = {};

    for (var i in obj) {
      if (keys.indexOf(i) >= 0) continue;
      if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
      target[i] = obj[i];
    }

    return target;
  };

  var possibleConstructorReturn = function (self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  };

  // FontAwesome

  var FieldAddonAppend = function (_React$Component) {
    inherits(FieldAddonAppend, _React$Component);

    function FieldAddonAppend() {
      classCallCheck(this, FieldAddonAppend);
      return possibleConstructorReturn(this, (FieldAddonAppend.__proto__ || Object.getPrototypeOf(FieldAddonAppend)).apply(this, arguments));
    }

    createClass(FieldAddonAppend, [{
      key: 'render',
      value: function render() {
        var _props = this.props,
            icon = _props.icon,
            text = _props.text;


        if (!icon && !text) {
          return '';
        }

        var content = text;
        if (icon) {
          content = React.createElement(reactFontawesome.FontAwesomeIcon, { icon: icon, fixedWidth: true });
        }

        return React.createElement(
          reactstrap.InputGroupAddon,
          { addonType: 'append' },
          React.createElement(
            reactstrap.InputGroupText,
            null,
            content
          )
        );
      }
    }]);
    return FieldAddonAppend;
  }(React.Component);

  FieldAddonAppend.propTypes = {
    icon: PropTypes.oneOfType([PropTypes.object, PropTypes.array, PropTypes.string]),
    text: PropTypes.string
  };

  // FontAwesome

  var FieldAddonPrepend = function (_React$Component) {
    inherits(FieldAddonPrepend, _React$Component);

    function FieldAddonPrepend() {
      classCallCheck(this, FieldAddonPrepend);
      return possibleConstructorReturn(this, (FieldAddonPrepend.__proto__ || Object.getPrototypeOf(FieldAddonPrepend)).apply(this, arguments));
    }

    createClass(FieldAddonPrepend, [{
      key: 'render',
      value: function render() {
        var _props = this.props,
            icon = _props.icon,
            text = _props.text;


        if (!icon && !text) {
          return '';
        }

        var content = text;
        if (icon) {
          content = React.createElement(reactFontawesome.FontAwesomeIcon, { icon: icon, fixedWidth: true });
        }

        return React.createElement(
          reactstrap.InputGroupAddon,
          { addonType: 'prepend' },
          React.createElement(
            reactstrap.InputGroupText,
            null,
            content
          )
        );
      }
    }]);
    return FieldAddonPrepend;
  }(React.Component);

  FieldAddonPrepend.propTypes = {
    icon: PropTypes.oneOfType([PropTypes.object, PropTypes.array, PropTypes.string]),
    text: PropTypes.string
  };

  // PropTypes

  var FieldFeedback = function (_React$Component) {
    inherits(FieldFeedback, _React$Component);

    function FieldFeedback() {
      classCallCheck(this, FieldFeedback);
      return possibleConstructorReturn(this, (FieldFeedback.__proto__ || Object.getPrototypeOf(FieldFeedback)).apply(this, arguments));
    }

    createClass(FieldFeedback, [{
      key: 'render',
      value: function render() {
        var error = this.props.error;

        if (!error) {
          return '';
        }

        return React.createElement(
          reactstrap.FormFeedback,
          null,
          error
        );
      }
    }]);
    return FieldFeedback;
  }(React.Component);

  FieldFeedback.propTypes = {
    error: PropTypes.string
  };

  // PropTypes

  var defaultProps = {
    required: false
  };

  var propTypes = {
    name: PropTypes.string,
    required: PropTypes.bool,
    text: PropTypes.string
  };

  var FieldLabel = function (_React$Component) {
    inherits(FieldLabel, _React$Component);

    function FieldLabel() {
      classCallCheck(this, FieldLabel);
      return possibleConstructorReturn(this, (FieldLabel.__proto__ || Object.getPrototypeOf(FieldLabel)).apply(this, arguments));
    }

    createClass(FieldLabel, [{
      key: 'render',
      value: function render() {
        var _props = this.props,
            name = _props.name,
            required = _props.required,
            text = _props.text;


        if (!text) {
          return '';
        }

        if (!required) {
          return React.createElement(
            reactstrap.Label,
            { 'for': name },
            text
          );
        }

        return React.createElement(
          reactstrap.Label,
          { 'for': name },
          text,
          ' ',
          React.createElement(
            'em',
            { className: 'required' },
            '*'
          )
        );
      }
    }]);
    return FieldLabel;
  }(React.Component);

  FieldLabel.defaultProps = defaultProps;
  FieldLabel.propTypes = propTypes;

  // PropTypes

  var FieldText = function (_React$Component) {
    inherits(FieldText, _React$Component);

    function FieldText() {
      classCallCheck(this, FieldText);
      return possibleConstructorReturn(this, (FieldText.__proto__ || Object.getPrototypeOf(FieldText)).apply(this, arguments));
    }

    createClass(FieldText, [{
      key: 'render',
      value: function render() {
        var text = this.props.text;

        if (!text) {
          return '';
        }

        return React.createElement(
          reactstrap.FormText,
          null,
          text
        );
      }
    }]);
    return FieldText;
  }(React.Component);

  FieldText.propTypes = {
    text: PropTypes.string
  };

  var FormContext = React.createContext();

  // Components

  var withFormApi = function withFormApi(Component) {
    return React.forwardRef(function (props, ref) {
      return React.createElement(
        FormContext.Consumer,
        null,
        function (_ref) {
          var formApi = _ref.formApi;
          return React.createElement(Component, _extends({ formApi: formApi, ref: ref }, props));
        }
      );
    });
  };

  // Components

  var Field = function (_React$Component) {
    inherits(Field, _React$Component);

    function Field(props) {
      classCallCheck(this, Field);

      var _this = possibleConstructorReturn(this, (Field.__proto__ || Object.getPrototypeOf(Field)).call(this, props));

      _this.state = {
        disabled: props.disabled,
        error: props.formApi.getError(props.name),
        options: props.options,
        required: props.required,
        validatorsEnabled: props.validatorsEnabled,
        value: props.formApi.getValue(props.name),
        visible: props.visible
      };

      _this.handleBlur = _this.handleBlur.bind(_this);
      _this.handleChange = _this.handleChange.bind(_this);
      return _this;
    }

    createClass(Field, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        var formApi = this.props.formApi;


        formApi.set(this.props.name, this);
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        var formApi = this.props.formApi;


        formApi.remove(this.props.name);
      }
    }, {
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        if (nextProps.disabled !== this.props.disabled) {
          this.setState({
            disabled: nextProps.disabled
          });
        }
        if (nextProps.error !== this.props.error) {
          console.log('Nastavovat pouze pres Form');
          this.setState({
            error: nextProps.error
          });
        }
        if (nextProps.options !== this.props.options) {
          this.setState({
            options: nextProps.options
          });
        }
        if (nextProps.required !== this.props.required) {
          this.setState({
            required: nextProps.required
          });
        }
        if (nextProps.validatorsEnabled !== this.props.validatorsEnabled) {
          this.setState({
            validatorsEnabled: nextProps.validatorsEnabled
          });
        }
        if (nextProps.value !== this.props.value) {
          console.log('Nastavovat pouze pres Form');
          this.setState({
            value: nextProps.value
          });
        }
        if (nextProps.visible !== this.props.visible) {
          this.setState({
            visible: nextProps.visible
          });
        }
      }
    }, {
      key: 'updateState',
      value: function updateState() {
        var formApi = this.props.formApi;


        this.setState(_extends({}, this.state, {
          error: formApi.getError(this.props.name),
          touched: formApi.getTouched(this.props.name),
          value: formApi.getValue(this.props.name)
        }));
      }
    }, {
      key: 'handleBlur',
      value: function handleBlur(e) {
        var formApi = this.props.formApi;


        formApi.setValue(e.target.name, e.target.value);
      }
    }, {
      key: 'handleChange',
      value: function handleChange(e) {
        var formApi = this.props.formApi;


        formApi.setValue(e.target.name, e.target.value);
      }
    }, {
      key: 'render',
      value: function render() {
        var _props = this.props,
            addonAppendIcon = _props.addonAppendIcon,
            addonAppendText = _props.addonAppendText,
            addonPrependIcon = _props.addonPrependIcon,
            addonPrependText = _props.addonPrependText,
            disabledIfEmptyOptions = _props.disabledIfEmptyOptions,
            label = _props.label,
            name = _props.name,
            optionsEmpty = _props.optionsEmpty,
            text = _props.text,
            type = _props.type;
        var _state = this.state,
            error = _state.error,
            options = _state.options,
            required = _state.required,
            visible = _state.visible;
        var _state2 = this.state,
            disabled = _state2.disabled,
            value = _state2.value;


        if (!visible) {
          return '';
        }

        var field = null;
        switch (type) {
          case 'select':
            if (true === disabledIfEmptyOptions && 0 === options.length) {
              disabled = true;
            }

            if (0 === options.length) {
              value = '';
            }

            field = React.createElement(
              reactstrap.Input,
              {
                disabled: disabled,
                invalid: !!error,
                name: name,
                onBlur: this.handleBlur,
                onChange: this.handleChange,
                required: required,
                type: type,
                value: value || ''
              },
              optionsEmpty && React.createElement(
                'option',
                { value: '' },
                '-'
              ),
              this.renderOptions()
            );
            break;
          default:
            field = React.createElement(reactstrap.Input, {
              disabled: disabled,
              invalid: !!error,
              name: name,
              onBlur: this.handleBlur,
              onChange: this.handleChange,
              required: required,
              type: type,
              value: !value && value !== 0 ? '' : value
            });
        }

        return React.createElement(
          reactstrap.FormGroup,
          null,
          React.createElement(FieldLabel, { name: name, required: required, text: label }),
          React.createElement(
            reactstrap.InputGroup,
            null,
            React.createElement(FieldAddonPrepend, { icon: addonPrependIcon, text: addonPrependText }),
            field,
            React.createElement(FieldAddonAppend, { icon: addonAppendIcon, text: addonAppendText }),
            React.createElement(FieldFeedback, { error: error })
          ),
          React.createElement(FieldText, { text: text })
        );
      }
    }, {
      key: 'renderOptions',
      value: function renderOptions() {
        var _props2 = this.props,
            options = _props2.options,
            optionsKey = _props2.optionsKey,
            optionsValue = _props2.optionsValue;


        return options.map(function (option) {
          return React.createElement(
            'option',
            { key: option[optionsKey], value: option[optionsKey] },
            option[optionsValue]
          );
        });
      }
    }]);
    return Field;
  }(React.Component);

  Field.defaultProps = {
    addonAppendIcon: null,
    addonAppendText: null,
    addonPrependIcon: null,
    addonPrependText: null,
    disabled: false,
    disabledIfEmptyOptions: true,
    disabledIfInvalid: [],
    options: [],
    optionsEmpty: true,
    required: false,
    requiredIfNotEmpty: [],
    text: null,
    touched: false,
    type: 'text',
    validateIfChange: [],
    validateOnChange: true,
    validators: [],
    validatorsEnabled: true,
    value: '',
    visible: true
  };

  Field.propTypes = {
    addonAppendIcon: PropTypes.oneOfType([PropTypes.object, PropTypes.array, PropTypes.string]),
    addonAppendText: PropTypes.string,
    addonPrependIcon: PropTypes.oneOfType([PropTypes.object, PropTypes.array, PropTypes.string]),
    addonPrependText: PropTypes.string,
    disabled: PropTypes.bool,
    disabledIfEmptyOptions: PropTypes.bool,
    disabledIfInvalid: PropTypes.array,
    label: PropTypes.string,
    name: PropTypes.string.isRequired,
    onBlur: PropTypes.func,
    onBlurIfValid: PropTypes.func,
    onChange: PropTypes.func,
    onChangeIfValid: PropTypes.func,
    options: PropTypes.oneOfType([PropTypes.array, PropTypes.object]),
    optionsEmpty: PropTypes.bool,
    optionsKey: PropTypes.string,
    optionsValue: PropTypes.string,
    required: PropTypes.bool,
    requiredIfNotEmpty: PropTypes.array,
    ref: PropTypes.func,
    text: PropTypes.string,
    touched: PropTypes.bool,
    type: PropTypes.string,
    validateIfChange: PropTypes.array,
    validateOnChange: PropTypes.bool,
    validators: PropTypes.array,
    validatorsEnabled: PropTypes.bool,
    visible: PropTypes.bool,
    value: PropTypes.oneOfType([PropTypes.number, PropTypes.string])
  };

  var Field$1 = withFormApi(Field);

  function buildMap(cursor) {
      if (isObject(cursor)) {
          // Cursor is an object so we need a new map
          const map = new Map();
          // Iterate over each field and set to result
          Object.keys(cursor).forEach(key => {
              const result = buildMap(cursor[key]);
              if (result != null) map.set(key, result);
          });
          // Return our new map
          return map;
      } else if (isArray(cursor)) {
          // Cursor is an array so we need a new map
          const map = new Map();
          // Iterate over each element and set to result
          cursor.forEach((value, i) => {
              const result = buildMap(value);
              if (result != null) map.set(i, result);
          });
          // Return our new map
          return map;
      }
      // Base case, cursor is not object or array
      else {
          return cursor;
      }
  }

  function isArray(a) {
      return Array.isArray(a);
  }

  function isObject(a) {
      return !Array.isArray(a) && typeof a === 'object' && a !== null;
  }

  function makePathArray(path) {

      if (typeof path !== "string" && isArray(path)) {
          return path;
      }

      return path
          .replace(/\[(\d+)]/g, '.__int__$1')
          .replace(/\[([^[\]]*)]/g, '.$1')
          .split('.')
          .map(e => (e.indexOf('__int__') === 0 ? parseInt(e.substring(7), 10) : e));
  }

  class DataMap {

      constructor(object = {}) {
          this.object = JSON.parse(JSON.stringify(object));
          this.map = buildMap(this.object);
          this.paths = new Map();
      }

      empty() {
          return this.map.size === 0;
      }

      has (path) {
          const value = this.get(path);

          return !!value;
      }

      get(path) {
          // Get the path array from our registered paths
          let pathArray = this.paths.get(path);

          // Check to see if path exists and if not build and add it to our paths
          if (!pathArray) {
              pathArray = makePathArray(path);
              this.paths.set(path, pathArray);
          }

          const get = (cursor, key, nextKey, i) => {
              // Base case1: cursor is undefined so just return
              if (cursor == null) {
                  return;
              }
              // Base case2: next key is undefined
              if (nextKey == null) {
                  return cursor[key];
              }
              // Recur
              return get(cursor[key], pathArray[i + 1], pathArray[i + 2], i + 1);
          };

          // Start recuring
          return get(this.object, pathArray[0], pathArray[1], 0);
      }

      set(path, value, del) {
          // Get the path array from our registered paths
          let pathArray = this.paths.get(path);

          // Check to see if path exists and if not build and add it to our paths
          if (!pathArray) {
              pathArray = makePathArray(path);
              this.paths.set(path, pathArray);
          }

          const set = (cursor, map, key, nextKey, i) => {
              // Base case 1: cursor is undefined
              if (cursor == null) {
                  return;
              }

              // Base case 2: next key is undefined
              if (nextKey == null) {
                  if (value == null) {
                      if (isArray(cursor) && del) {
                          cursor.splice(key, 1);
                      } else {
                          delete cursor[key];
                      }
                      map.delete(key);
                  } else {
                      cursor[key] = value;
                      map.set(key, value);
                  }
                  return;
              }

              // We only initialize if the value is not null or undefined
              if (value != null) {
                  // If the next key is a number and the cursor is not an array yet we
                  // need to initialize it.
                  if (typeof nextKey === 'number' && !isArray(cursor[key])) {
                      cursor[key] = [];
                      map.set(key, new Map());
                  }
                  // If the next key is not a number and the cursor is not an object yet
                  // we need to initialize it
                  if (typeof nextKey !== 'number' && !isObject(cursor[key])) {
                      cursor[key] = {};
                      map.set(key, new Map());
                  }
              }

              // If the next cursor is an array or object then we pass down a new map
              const nextMap =
                  isObject(cursor[key]) || isArray(cursor[key]) ? map.get(key) : map;

              // Recur
              set(cursor[key], nextMap, pathArray[i + 1], pathArray[i + 2], i + 1);

              // Check map
              if (nextMap.size === 0) {
                  delete cursor[key];
                  map.delete(key);
              }
          };

          // Start recuring
          set(this.object, this.map, pathArray[0], pathArray[1], 0);
      }

      delete(path) {
          this.set(path, null, true);
          this.paths.delete(path);
      }

  }

  // Components

  var Form = function (_React$Component) {
    inherits(Form, _React$Component);

    function Form(props) {
      classCallCheck(this, Form);

      var _this = possibleConstructorReturn(this, (Form.__proto__ || Object.getPrototypeOf(Form)).call(this, props));

      var values = props.values;


      _this.state = {
        isHighlightingErrors: false,
        isSubmitting: false
      };

      _this.errors = new DataMap();
      _this.fields = new Map();
      _this.fieldsDisabledIfInvalid = new Map();
      _this.fieldsRequiredIfNotEmpty = new Map();
      _this.fieldsTriggerDisabled = new Map();
      _this.filled = new DataMap();
      _this.touched = new DataMap();
      _this.values = new DataMap(values);

      if (props.onInit) {
        props.onInit(_this);
      }

      _this.get = _this.get.bind(_this);
      _this.getError = _this.getError.bind(_this);
      _this.getErrors = _this.getErrors.bind(_this);
      _this.getFilled = _this.getFilled.bind(_this);
      _this.getTouched = _this.getTouched.bind(_this);
      _this.getValue = _this.getValue.bind(_this);
      _this.getValues = _this.getValues.bind(_this);
      _this.has = _this.has.bind(_this);
      _this.handleChange = _this.handleChange.bind(_this);
      _this.handleSubmit = _this.handleSubmit.bind(_this);
      _this.remove = _this.remove.bind(_this);
      _this.set = _this.set.bind(_this);
      _this.setError = _this.setError.bind(_this);
      _this.setTouched = _this.setTouched.bind(_this);
      _this.setValue = _this.setValue.bind(_this);
      return _this;
    }

    createClass(Form, [{
      key: 'set',
      value: function set$$1(name, field) {
        var _this2 = this;

        this.fields.set(name, field);

        // Disabled if not valid
        if (field.props.disabledIfInvalid.length > 0) {
          this.fieldsDisabledIfInvalid.set(name, field.props.disabledIfInvalid);

          field.props.disabledIfInvalid.forEach(function (fieldToCheck) {
            if (!_this2.fieldsTriggerDisabled.has(fieldToCheck)) {
              _this2.fieldsTriggerDisabled.set(fieldToCheck, []);
            }

            _this2.fieldsTriggerDisabled.get(fieldToCheck).push(name);
          });
        }

        // Required if not empty
        if (field.props.requiredIfNotEmpty.length > 0) {
          this.fieldsRequiredIfNotEmpty.set(name, field.props.requiredIfNotEmpty);
        }

        // Default value
        if (this.values.has(name)) {
          field.setState({
            value: this.values.get(name)
          });
        }
      }
    }, {
      key: 'get',
      value: function get$$1(name) {
        return this.fields.get(name);
      }
    }, {
      key: 'has',
      value: function has(name) {
        return this.fields.has(name);
      }
    }, {
      key: 'remove',
      value: function remove(name) {
        this.fields.delete(name);
      }
    }, {
      key: 'setError',
      value: function setError(name, error) {
        if (null === error) {
          this.errors.delete(name);
        } else {
          this.errors.set(name, error);
        }

        this.fields.get(name).setState({
          error: error
        });
      }
    }, {
      key: 'setTouched',
      value: function setTouched(name, value) {
        this.touched.set(name, value);
      }
    }, {
      key: 'setValue',
      value: function setValue(name, value) {
        value = value || null;

        this.values.set(name, value);

        if (this.fields.has(name)) {
          this.handleChange(name, value);
        }
      }
    }, {
      key: 'getValue',
      value: function getValue(name) {
        if (!this.values.has(name)) {
          return null;
        }

        return this.values.get(name);
      }
    }, {
      key: 'getError',
      value: function getError(name) {
        if (!this.errors.has(name)) {
          return null;
        }

        return this.errors.get(name);
      }
    }, {
      key: 'getErrors',
      value: function getErrors() {
        return this.errors;
      }
    }, {
      key: 'getFilled',
      value: function getFilled() {
        var name = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

        if (null !== name) {
          if (this.filled.has(name)) {
            return this.filled.get(name);
          }

          return null;
        }

        return this.filled;
      }
    }, {
      key: 'getTouched',
      value: function getTouched(name) {
        if (!this.touched.has(name)) {
          return null;
        }

        return this.touched.get(name);
      }
    }, {
      key: 'getValues',
      value: function getValues() {
        return this.values;
      }
    }, {
      key: 'handleChange',
      value: function () {
        var _ref = asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(name, value) {
          var _this3 = this;

          var field, error, namesToCheck, isRequired;
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  field = this.fields.get(name);

                  if (!(value === field.state.value)) {
                    _context.next = 3;
                    break;
                  }

                  return _context.abrupt('return', false);

                case 3:

                  // Filled
                  if ('' === value || null === value) {
                    this.filled.delete(name);
                  } else {
                    this.filled.set(name, true);
                  }

                  // Touched
                  this.touched.set(name, true);

                  // Validation
                  if (true === field.props.validateOnChange) {
                    error = this.handleValidate(name, value);


                    if (!error) {
                      this.errors.delete(name);
                    } else {
                      this.errors.set(name, error);
                    }
                  }

                  // On blur
                  if (field.props.hasOwnProperty('onBlur') && typeof field.props.onBlur === 'function') {
                    field.props.onBlur(name, value, this.values.object);
                  }

                  // On blur if valid
                  if (field.props.hasOwnProperty('onBlurIfValid') && typeof field.props.onBlurIfValid === 'function' && !this.errors.get(name)) {
                    field.props.onBlurIfValid(name, value, this.values.object);
                  }

                  // On change
                  if (field.props.hasOwnProperty('onChange') && typeof field.props.onChange === 'function') {
                    field.props.onChange(name, value, this.values.object);
                  }

                  // On change if valid
                  if (field.props.hasOwnProperty('onChangeIfValid') && typeof field.props.onChangeIfValid === 'function' && !this.errors.get(name)) {
                    field.props.onChangeIfValid(name, value, this.values.object);
                  }

                  // Disabled if not valid

                  if (!this.fieldsTriggerDisabled.has(name)) {
                    _context.next = 13;
                    break;
                  }

                  _context.next = 13;
                  return this.fieldsTriggerDisabled.get(name).forEach(function (nameToDisable) {
                    if (_this3.fieldsDisabledIfInvalid.has(nameToDisable)) {
                      var isValid = true;
                      _this3.fieldsDisabledIfInvalid.get(nameToDisable).forEach(function (nameToCheckValue) {
                        if (true === isValid && _this3.errors.has(nameToCheckValue)) {
                          isValid = false;
                        }
                      });

                      if (true === isValid) {
                        _this3.fields.get(nameToDisable).setState({
                          disabled: false
                        });
                      } else {
                        _this3.errors.delete(nameToDisable);
                        _this3.values.set(nameToDisable, '');
                        _this3.fields.get(nameToDisable).setState({
                          error: null,
                          disabled: true,
                          options: [],
                          value: ''
                        });
                      }
                    }
                  });

                case 13:
                  if (!this.fieldsRequiredIfNotEmpty.has(name)) {
                    _context.next = 19;
                    break;
                  }

                  namesToCheck = this.fieldsRequiredIfNotEmpty.get(name);

                  // Is some field filled?

                  isRequired = false;

                  namesToCheck.forEach(function (nameToCheck) {
                    if (false === isRequired) {
                      if (!!_this3.values.get(nameToCheck)) {
                        isRequired = true;
                      }
                    }
                  });

                  // Change state of fields
                  _context.next = 19;
                  return this.fieldsRequiredIfNotEmpty.forEach(function (field, nameToChange) {
                    if (_this3.fields.has(nameToChange)) {
                      var fieldToChange = _this3.fields.get(nameToChange);

                      if (fieldToChange.state.required !== isRequired) {
                        if (true === isRequired) {
                          fieldToChange.setState({
                            required: isRequired,
                            validatorsEnabled: isRequired
                          });
                        } else {
                          fieldToChange.setState({
                            error: null,
                            required: isRequired,
                            validatorsEnabled: isRequired
                          });
                        }
                      }
                    }
                  });

                case 19:

                  if (this.props.hasOwnProperty('onChange') && typeof this.props.onChange === 'function') {
                    this.props.onChange(this.values.object, name, value);
                  }

                  field.updateState();

                case 21:
                case 'end':
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        function handleChange(_x2, _x3) {
          return _ref.apply(this, arguments);
        }

        return handleChange;
      }()
    }, {
      key: 'handleSubmit',
      value: function () {
        var _ref2 = asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(e) {
          var _this4 = this;

          return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  e.preventDefault(e);

                  _context2.next = 3;
                  return this.setState({
                    isSubmitting: true
                  });

                case 3:
                  _context2.next = 5;
                  return this.fields.forEach(function (field, name) {
                    var error = _this4.handleValidate(name, _this4.values.get(name));

                    _this4.setError(name, error);
                  });

                case 5:
                  if (!this.errors.empty()) {
                    _context2.next = 9;
                    break;
                  }

                  _context2.next = 8;
                  return this.props.onSubmit(this.values.object);

                case 8:
                  return _context2.abrupt('return');

                case 9:
                  _context2.next = 11;
                  return this.setState({
                    isHighlightingErrors: true,
                    isSubmitting: false
                  });

                case 11:

                  setTimeout(function () {
                    this.setState({
                      isHighlightingErrors: false
                    });
                  }.bind(this), 500);

                case 12:
                case 'end':
                  return _context2.stop();
              }
            }
          }, _callee2, this);
        }));

        function handleSubmit(_x4) {
          return _ref2.apply(this, arguments);
        }

        return handleSubmit;
      }()
    }, {
      key: 'handleValidate',
      value: function handleValidate(name) {
        var _this5 = this;

        var value = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
        var validateWithSkip = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

        var error = null;
        var field = this.fields.get(name);

        if (false === field.state.validatorsEnabled) {
          return null;
        }
        if (field.state.visible) {
          value = value || '';

          field.props.validators.forEach(function (validator) {
            if (null === error) {
              error = validator.validate(value.trim(), _this5.getValues());

              field.props.validateIfChange.forEach(function (nameToValidate) {
                if (nameToValidate !== validateWithSkip && _this5.fields.has(nameToValidate)) {
                  if (_this5.touched.has(nameToValidate)) {
                    var fieldError = _this5.handleValidate(nameToValidate, _this5.values.get(nameToValidate), name);

                    _this5.setError(nameToValidate, fieldError);
                  }
                }
              });
            }
          });
        }

        return error;
      }
    }, {
      key: 'render',
      value: function render() {
        var _props = this.props,
            children = _props.children,
            component = _props.component,
            render = _props.render,
            noValidate = _props.noValidate,
            onChange = _props.onChange,
            onInit = _props.onInit,
            onSubmit = _props.onSubmit,
            values = _props.values,
            rest = objectWithoutProperties(_props, ['children', 'component', 'render', 'noValidate', 'onChange', 'onInit', 'onSubmit', 'values']);


        return React.createElement(
          FormContext.Provider,
          { value: this.formContext },
          React.createElement(
            reactstrap.Form,
            _extends({}, rest, {
              className: this.formClassName,
              onSubmit: this.handleSubmit
            }),
            this.content
          )
        );
      }
    }, {
      key: 'formClassName',
      get: function get$$1() {
        return this.state.isHighlightingErrors ? 'invalid-highlight' : null;
      }
    }, {
      key: 'formContext',
      get: function get$$1() {
        return {
          formApi: {
            get: this.get,
            getError: this.getError,
            getErrors: this.getErrors,
            getFilled: this.getFilled,
            getTouched: this.getTouched,
            getValue: this.getValue,
            getValues: this.getValues,
            has: this.has,
            isSubmitting: this.state.isSubmitting,
            remove: this.remove,
            set: this.set,
            setError: this.setError,
            setTouched: this.setTouched,
            setValue: this.setValue
          }
        };
      }
    }, {
      key: 'content',
      get: function get$$1() {
        var _props2 = this.props,
            children = _props2.children,
            component = _props2.component,
            render = _props2.render;


        var props = this.formContext;

        if (component) {
          return React.createElement(component, props, children);
        }
        if (render) {
          return render(props);
        }
        if (typeof children === 'function') {
          return children(props);
        }
        return children;
      }
    }]);
    return Form;
  }(React.Component);

  Form.defaultProps = {
    noValidate: true,
    onChange: null,
    values: {}
  };

  Form.propTypes = {
    noValidate: PropTypes.bool,
    onInit: PropTypes.func,
    onChange: PropTypes.func,
    onSubmit: PropTypes.func.isRequired,
    values: PropTypes.object
  };

  // HOC

  var buildFieldApi = function buildFieldApi(formApi, name) {
    return {
      set: function set$$1(field) {
        return formApi.set(name, field);
      },
      remove: function remove() {
        return formApi.remove(name);
      },
      getValue: function getValue() {
        return formApi.getValue(name);
      },
      setValue: function setValue(value) {
        return formApi.setValue(name, value);
      },
      getTouched: function getTouched() {
        return formApi.getTouched(name);
      },
      setTouched: function setTouched(value) {
        return formApi.setTouched(name, value);
      },
      getError: function getError() {
        return formApi.getError(name);
      },
      setError: function setError(value) {
        return formApi.setError(name, value);
      }
    };
  };

  var buildFieldState = function buildFieldState(formApi, name) {
    return {
      disabled: false,
      error: formApi.getError(name),
      touched: formApi.getTouched(name),
      required: false,
      visible: true,
      value: formApi.getValue(name)
    };
  };

  var withField = function withField(Component) {
    return withFormApi(function (_React$PureComponent) {
      inherits(_class, _React$PureComponent);

      function _class(props) {
        classCallCheck(this, _class);

        var _this = possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, props));

        var formApi = props.formApi,
            name = props.name;


        _this.fieldApi = buildFieldApi(formApi, name);
        _this.fieldState = buildFieldState(formApi, name);

        // Rebuild state when name changes
        _this.fieldStateUpdate = function () {
          console.log(_this);
          _this.setState(buildFieldState(formApi, name));
        };
        return _this;
      }

      createClass(_class, [{
        key: 'render',
        value: function render() {
          var rest = objectWithoutProperties(this.props, []);

          return React.createElement(Component, _extends({
            fieldApi: this.fieldApi,
            fieldState: this.fieldState,
            fieldStateUpdate: this.fieldStateUpdate
          }, rest));
        }
      }]);
      return _class;
    }(React.PureComponent));
  };

  var withFieldApi = function withFieldApi(field) {
    return function (Component) {
      return withFormApi(function (_ref) {
        var formApi = _ref.formApi,
            props = objectWithoutProperties(_ref, ['formApi']);
        return React.createElement(Component, _extends({ fieldApi: buildFieldApi(formApi, field) }, props));
      });
    };
  };

  var withFieldState = function withFieldState(field) {
    return function (Component) {
      return withFormApi(function (_ref2) {
        var formApi = _ref2.formApi,
            props = objectWithoutProperties(_ref2, ['formApi']);
        return React.createElement(Component, _extends({ fieldState: buildFieldState(formApi, field) }, props));
      });
    };
  };

  exports.Field = Field$1;
  exports.FieldAddonAppend = FieldAddonAppend;
  exports.FieldAddonPrepend = FieldAddonPrepend;
  exports.FieldFeedback = FieldFeedback;
  exports.FieldLabel = FieldLabel;
  exports.FieldText = FieldText;
  exports.Form = Form;
  exports.FormContext = FormContext;
  exports.withField = withField;
  exports.withFieldApi = withFieldApi;
  exports.withFieldState = withFieldState;
  exports.withFormApi = withFormApi;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=lemo-form.js.map
